//*********************************************************************************************************************************
//	File:				DMWinService.cs
//	App:				Device Manager 
//  Date Created:		16.08.2005
//
//	Version:			1.0
//	Author:				Panayot Daskalov
//	E-Mail:				panayot.daskalov@mps.bg
//	Company:			MPS Ltd.
//
//	Updates:			
//	
//	Copyright:			2005, MPS Ltd. This software is property of MPS Ltd. and any kind of distrubution, editing and using in 
//									   applications other than the one specified, without the appropriate permition is strictly
//									   forbidden.				
//********************************************************************************************************************************

using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.ServiceProcess;

//added by me
using U1;
using System.Runtime.Remoting;
using System.Runtime.Remoting.Channels;
using System.Runtime.Remoting.Channels.Tcp;



namespace DMWinService
{
	public class DMWinService : System.ServiceProcess.ServiceBase
	{
		
		#region Main

		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public DMWinService()
		{
			// This call is required by the Windows.Forms Component Designer.
			InitializeComponent();
			
			//!!! THIS DATA SHOULD NOT BE HARD CODED!!!
			dbConnData = "User Id=test; Host=test; Database=ddb; Password=test; Port=3306; Min Pool Size=5; Max Pool Size=1010; Pooling=true; Direct=true;" ; 							
			
			//register remote server-activated objects
			tcpChnl = new TcpChannel(30301);	//assign port to listen on for client requests
			ChannelServices.RegisterChannel(tcpChnl);	//register the channel in the remoting framework
			
			U1srv = new Server("10.0.0.89",30300, dbConnData);

			ObjRef srvRef = RemotingServices.Marshal(U1srv, "U1srvURI");
		}


		// The main entry point for the process
		static void Main()
		{
			System.ServiceProcess.ServiceBase[] ServicesToRun;
	
			ServicesToRun = new System.ServiceProcess.ServiceBase[] { new DMWinService() };

			System.ServiceProcess.ServiceBase.Run(ServicesToRun);
		}

		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			//
			//DMWinService
			//
			this.ServiceName = "Device Manager";
			
		}

		#endregion
		
		#region Variables

		//contains DB connection data (user, password etc.)
		string dbConnData;	
	
		//U1 server object
		Server U1srv;

		//channel for communications with remote clients
		TcpChannel tcpChnl;

		#endregion	
		
		#region Event Handlers

		/// <summary>
		/// Starts the U1 server
		/// </summary>
		protected override void OnStart(string[] args)
		{
			//Start the server
			U1srv.Start();
		}
 

		/// <summary>
		/// Stops the U1 server
		/// </summary>
		protected override void OnStop()
		{			
			//unregister remote server object
			RemotingServices.Disconnect(U1srv);

			//disconnecte remote listening channel
			ChannelServices.UnregisterChannel(tcpChnl);			
			
			//stop the server
			U1srv.Stop();

			//ensure that all server objects are collected
			GC.Collect();
			GC.WaitForPendingFinalizers();
		}
		

		#endregion
		
		#region Clean-Up Methods

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#endregion
		
	}
}
